<?php
//
// +----------------------------------------------------------------------+
// |zen-cart Open Source E-commerce                                       |
// +----------------------------------------------------------------------+
// | Copyright (c) 2003 The zen-cart developers                           |
// |                                                                  			    |
// | http://www.zen-cart.com/index.php                                    |
// |                                                                			      |
// | Portions Copyright (c) 2003 osCommerce                               |
// +----------------------------------------------------------------------+
// | This source file is subject to version 2.0 of the GPL license,       |
// | that is bundled with this package in the file LICENSE, and is        |
// | available through the world-wide-web at the following url:           |
// | http://www.zen-cart.com/license/2_0.txt.                             |
// | If you did not receive a copy of the zen-cart license and are unable |
// | to obtain it through the world-wide-web, please send a note to       |
// | license@zen-cart.com so we can mail you a copy immediately.          |
// +----------------------------------------------------------------------+
// | SagePay Form Payment Services Module          			              |
// | 				       			        				      |
// | includes/modules/payment/sagepay_form.php           |
// | 				       			        				      |
// | Released under GPL   							  |
// | 				       			        				      |
// | Designed by Nixak								  |
// | Version 1.3 9th Feb 2010							              |
// +----------------------------------------------------------------------+
//$Id: SagePay_form.php,v 1.3 09022010$
// +----------------------------------------------------------------------+

// File protection as per Zen-Cart suggestions
	if (!defined('IS_ADMIN_FLAG')) {
	  die('Illegal Access');
}
//EOF: File protection

  class sagepay_form {
    var $code, $title, $description, $enabled;

	// class constructor
    function sagepay_form() {
      global $order;
      $this->code = 'sagepay_form';
      $this->title = MODULE_PAYMENT_SAGEPAY_FORM_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_SAGEPAY_FORM_TEXT_DESCRIPTION;
      $this->enabled = ((MODULE_PAYMENT_SAGEPAY_FORM_STATUS == 'True') ? true : false);
      $this->sort_order = MODULE_PAYMENT_SAGEPAY_FORM_SORT_ORDER;

      if ((int)MODULE_PAYMENT_SAGEPAY_FORM_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_SAGEPAY_FORM_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();

      if (MODULE_PAYMENT_SAGEPAY_FORM_TEST_STATUS == 'simulator') {
	// Simulator mode
        $this->form_action_url = 'https://test.sagepay.com/simulator/vspformgateway.asp';
		} elseif (MODULE_PAYMENT_SAGEPAY_FORM_TEST_STATUS == 'test') {
    // Test mode
        $this->form_action_url = 'https://test.sagepay.com/gateway/service/vspform-register.vsp';
		} else {
	// Live mode
        $this->form_action_url = 'https://live.sagepay.com/gateway/service/vspform-register.vsp';
		}
    }

	// class methods
    function update_status() {
      global $order, $db;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_SAGEPAY_FORM_ZONE > 0) ) {
        $check_flag = false;
        $check = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_SAGEPAY_FORM_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while (!$check->EOF) {
          if ($check->fields['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check->fields['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
          $check->MoveNext();
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      return false;
    }

    function simpleXor($InString, $Key) {
      $KeyList = array();
      $output = "";

      for($i = 0; $i < strlen($Key); $i++){
        $KeyList[$i] = ord(substr($Key, $i, 1));
      }

      for($i = 0; $i < strlen($InString); $i++) {
        $output.= chr(ord(substr($InString, $i, 1)) ^ ($KeyList[$i % strlen($Key)]));
      }

      return $output;
    }

    function getToken($thisString) {

      $Tokens = array("Status","StatusDetail","VendorTxCode","VPSTxID","TxAuthNo","Amount","AVSCV2");

      $output = array();
      $resultArray = array();

      for ($i = count($Tokens)-1; $i >= 0 ; $i--){
        $start = strpos($thisString, $Tokens[$i]);
        if ($start !== false){
          $resultArray[$i]->start = $start;
          $resultArray[$i]->token = $Tokens[$i];
        }
      }

      sort($resultArray);

      for ($i = 0; $i<count($resultArray); $i++){
        $valueStart = $resultArray[$i]->start + strlen($resultArray[$i]->token) + 1;
        if ($i==(count($resultArray)-1)) {
          $output[$resultArray[$i]->token] = substr($thisString, $valueStart);
        } else {
          $valueLength = $resultArray[$i+1]->start - $resultArray[$i]->start - strlen($resultArray[$i]->token) - 2;
          $output[$resultArray[$i]->token] = substr($thisString, $valueStart, $valueLength);
        }
      }

      return $output;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      return false;
    }
			
    function process_button() {
      global $order, $currencies, $currency, $customer_id, $cart, $products, $contents;

	// Currency selection switch
      switch (MODULE_PAYMENT_SAGEPAY_FORM_CURRENCY) {
        case 'Default Currency':
          $sagepay_currency = DEFAULT_CURRENCY;
          break;
        case 'GBP':
        default:
          $sagepay_currency = "GBP";
          break;
		  case 'EUR':
        default:
          $sagepay_currency = "EUR";
          break;
		  case 'USD':
        default:
          $sagepay_currency = "USD";
          break;
    }
	// EOF: Currency selection switch
	
	// US state code array
	//Returns the zone (State/Province) code
	$us_state_codes = array(
				'Alabama' => 'AL',
				'Alaska' => 'AK',
				'American Samoa' => 'AS',
				'Arizona' => 'AZ',
				'Arkansas' => 'AR',
				'Armed Forces Africa' => 'AF',
				'Armed Forces Americas' => 'AA',
				'Armed Forces Canada' => 'AC',
				'Armed Forces Europe' => 'AE',
				'Armed Forces Middle East' => 'AM',
				'Armed Forces Pacific' => 'AP',
				'California' => 'CA',
				'Colorado' => 'CO',
				'Connecticut' => 'CT',
				'Delaware' => 'DE',
				'District of Columbia' => 'DC',
				'Federated States Of Micronesia' => 'FM',
				'Florida' => 'FL',
				'Georgia' => 'GA',
				'Guam' => 'GU',
				'Hawaii' => 'HI',
				'Idaho' => 'ID',
				'Illinois' => 'IL',
				'Indiana' => 'IN',
				'Iowa' => 'IA',
				'Kansas' => 'KS',
				'Kentucky' => 'KY',
				'Louisiana' => 'LA',
				'Maine' => 'ME',
				'Marshall Islands' => 'MH',
				'Maryland' => 'MD',
				'Massachusetts' => 'MA',
				'Michigan' => 'MI',
				'Minnesota' => 'MN',
				'Mississippi' => 'MS',
				'Missouri' => 'MO',
				'Montana' => 'MT',
				'Nebraska' => 'NE',
				'Nevada' => 'NV',
				'New Hampshire' => 'NH',
				'New Jersey' => 'NJ',
				'New Mexico' => 'NM',
				'New York' => 'NY',
				'North Carolina' => 'NC',
				'North Dakota' => 'ND',
				'Northern Mariana Islands' => 'MP',
				'Ohio' => 'OH',
				'Oklahoma' => 'OK',
				'Oregon' => 'OR',
				'Pennsylvania' => 'PA',
				'Puerto Rico' => 'PR',
				'Rhode Island' => 'RI',
				'South Carolina' => 'SC',
				'South Dakota' => 'SD',
				'Tennessee' => 'TN',
				'Texas' => 'TX',
				'Utah' => 'UT',
				'Vermont' => 'VT',
				'Virgin Islands' => 'VI',
				'Virginia' => 'VA',
				'Washington' => 'WA',
				'West Virginia' => 'WV',
				'Wisconsin' => 'WI',
				'Wyoming' => 'WY'
				);
	//EOF: US state code array
	
	// Email selection switch
	  switch (MODULE_PAYMENT_SAGEPAY_FORM_SENDEMAIL) {
		case 'none':
		  $SEMail = "0";
		  break;
		case 'both':
		default:
		  $SEMail = "1";
		  break;
		case "vendor":
		default:
		  $SEMail = "2";
		  break;
	}	  
	// EOF: Email selection switch
	
	
		$plain = "VendorTxCode=" . date('YmdHis') . $customer_id . "&";
		$plain .= "Amount=" . number_format($order->info['total'] * $currencies->get_value($sagepay_currency), $currencies->get_decimal_places($sagepay_currency)) . "&";
		$plain .= "Currency=" . $sagepay_currency . "&";
		$plain .= "Description=" . "Goods from " . STORE_NAME . "&";
		$plain .= "SuccessURL=" . zen_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL', true) . "&";
		$plain .= "FailureURL=" . zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true) . "&";
		$plain .= "CustomerName=" . $order->billing['firstname'] . ' ' . $order->billing['lastname'] . "&";
		$plain .= "CustomerEmail=" . $order->customer['email_address'] . "&";
		$plain .= "VendorEMail=" . STORE_OWNER_EMAIL_ADDRESS . "&";
		$plain .= "SendEMail=" . $SEMail . "&";
		
	// added BilliingXXX and DeliveryXXX fields for compatibility with Sagepay V2.23 protocol
		$plain .= "BillingSurname=" . $order->billing['lastname'] . "&";
		$plain .= "BillingFirstnames=" . $order->billing['firstname'] . "&";
		$plain .= "BillingAddress1=" . $order->billing['street_address'] . "&";
      if (ACCOUNT_SUBURB == 'true') {
        $plain .= "BillingAddress2=" . $order->billing['suburb'] . "&";
    }
		$plain .= "BillingCity=" . $order->billing['city'] . "&";
		$plain .= "BillingPostCode=" . $order->billing['postcode'] . "&";
		$plain .= "BillingCountry=" . $order->billing['country']['iso_code_2'] . "&";
		
	if (($order->billing['country']['iso_code_2']) == 'US') {
		$orderbillstate = $order->billing['state'];
		$plain .= "BillingState=" . $us_state_codes[$orderbillstate] . "&";
	 }else{
		$plain .= "BillingState=" . "&";
    }
	  
		$plain .= "BillingPhone=" . $order->customer['telephone'] . "&";	
		$plain .= "DeliverySurname=" . $order->delivery['lastname'] . "&";
		$plain .= "DeliveryFirstnames=" . $order->delivery['firstname'] . "&";
		$plain .= "DeliveryAddress1=" . $order->delivery['street_address'] . "&";
      if (ACCOUNT_SUBURB == 'true') {
        $plain .= "DeliveryAddress2=" . $order->delivery['suburb'] . "&";
    }
		$plain .= "DeliveryCity=" . $order->delivery['city'] . "&";
		$plain .= "DeliveryPostCode=" . $order->delivery['postcode'] . "&";
		$plain .= "DeliveryCountry=" . $order->delivery['country']['iso_code_2'] . "&";
		
	if (($order->delivery['country']['iso_code_2']) == 'US') {
		$orderdelivstate = $order->delivery['state'];
		$plain .= "DeliveryState=" . $us_state_codes[$orderdelivstate] . "&";
	 }else{
		$plain .= "DeliveryState=" . "&";
    }
      
		$plain .= "DeliveryPhone=" . $order->customer['telephone'] . "";
		
	// Basket detail code
      if (MODULE_PAYMENT_SAGEPAY_FORM_SHOPCART == 'true') {
		$shipping = $order->info['shipping_cost'];
		$shipping = number_format($shipping, 2, '.', '');
 		$products = $_SESSION['cart']->get_products();
		$no_lines = sizeof($products) + 1;
		
		$shippingStr .= ":Shipping:---:---:---:---:".$shipping;
		$basketStr = "Basket=".$no_lines;
		$moreStr .= ":More products...See Order.:---:---:---:---:---";
        $moreLen = strlen( $moreStr );
	/*
	Maxmium size of the basket field according to SAGEPAY Form Documentation V2.23 is 7500 characters.
	Allowing 7495 as a small safety net.
	*/
		$charCount = 7495 - strlen( $shippingStr ) - strlen( $basketStr );

		$detail = "";
        $linesAdded = 0;
        $i = 0;
        $n=sizeof($products);
        $finished = false;

    	while ( ( $i<$n ) && ( !$finished ) ) {
   				$desc = $order->products[$i]['name'];
				$desc  = str_replace(":", "", $desc);
				$qty = $order->products[$i]['qty'];
				$price = $order->products[$i]['price'] + $_SESSION['cart']->attributes_price($products[$i]['id']);
				$tax = $price/100 * zen_get_tax_rate($products[$i]['tax_class_id']);
				$tax = number_format($tax, 2, '.', '');
				$finalPrice = $price + $tax;
				$finalPrice = number_format($finalPrice, 2, '.', '');
				$lineTotal = $qty * $finalPrice;
				$lineTotal = number_format($lineTotal, 2, '.', '');
				$line = ":".$desc.":".$qty.":".$price.":".$tax.":".$finalPrice.":".$lineTotal;
				$line = str_replace("\n", "", $line);
		        $line = str_replace("\r", "", $line);
		        $len = strlen( $line );
		        if ( ( $charCount - $moreLen - $len) > 0 ) {
		            $linesAdded ++;
		            $charCount -= $len;
		            $detail .= $line;
		        } else if ( $charCount - $moreLen > 0 ) {
		            $detail .= $moreStr;
		            $charCount -= $len;
		            $linesAdded ++;
		            $finished = true;
		        }
		        else {
		            // We should not hit this point, but if we do lets fininsh
		            $finished = true;
		        }
		        $i++;
   		}

   		if ( strlen( $detail ) > 0 )
   		{
   		    $linesAdded ++;
   		    $retStr = "&" . "Basket=" . $linesAdded . $detail . $shippingStr;
   		}
    }
		$plain .= $retStr . "";
	//EOF: Basket detail code  
		
		$crypt = base64_encode($this->SimpleXor($plain, MODULE_PAYMENT_SAGEPAY_FORM_PASSWORD));

	// TxType selection
    if (MODULE_PAYMENT_SAGEPAY_FORM_TXTYPE == 'Payment') {
        $transaction_type = 'PAYMENT';
    } elseif (MODULE_PAYMENT_SAGEPAY_FORM_TXTYPE == 'Deferred') {
        $transaction_type = 'DEFERRED';
    } elseif (MODULE_PAYMENT_SAGEPAY_FORM_TXTYPE == 'Authenticate') {
		$transaction_type = 'AUTHENTICATE';
	}
	// EOF:TxType selection

      $process_button_string = zen_draw_hidden_field('VPSProtocol', '2.23') .
                               zen_draw_hidden_field('TxType', $transaction_type) .
                               zen_draw_hidden_field('Vendor', MODULE_PAYMENT_SAGEPAY_FORM_VENDOR_NAME) .
                               zen_draw_hidden_field('Crypt', $crypt);

      return $process_button_string;
    }

    function before_process() {
      global $_POST, $crypt;

      $Decoded = $this->SimpleXor(base64_decode($crypt),MODULE_PAYMENT_SAGEPAY_FORM_PASSWORD);
      $values = $this->getToken($Decoded);

    $Status=$values['Status'];
	$strStatusDetail=$values['StatusDetail'];


      if ($Status == 'true') {
        zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, zen_session_name() . '=' . $_POST[zen_session_name()] . '&error_message=' . urlencode($Status), 'SSL', true, false));
      }
	  return $Status;
    }
	
    function after_process() {
      return false;
    }

    function get_error() {
      global $_GET;

      if (isset($_GET['message']) && (strlen($_GET['message']) > 0)) {
        $error = stripslashes(urldecode($_GET['message']));
      } else {
        $error = MODULE_PAYMENT_SAGEPAY_FORM_TEXT_ERROR_MESSAGE;
      }

      return array('title' => MODULE_PAYMENT_SAGEPAY_FORM_TEXT_ERROR,
                   'error' => $error);
    }

    function check() {
      global $db;
      if (!isset($this->_check)) {
        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SAGEPAY_FORM_STATUS'");
        $this->_check = $check_query->RecordCount();
      }
      return $this->_check;
    }

    function install() {
      global $db;
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Sagepay Form Module', 'MODULE_PAYMENT_SAGEPAY_FORM_STATUS', 'True', 'Do you want to accept Sagepay Form payments?', '6', '0', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('SagePay Vendor Name', 'MODULE_PAYMENT_SAGEPAY_FORM_VENDOR_NAME', 'testvendor', 'Vendor Name to use with the Sagepay Form service.', '6', '1', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Password', 'MODULE_PAYMENT_SAGEPAY_FORM_PASSWORD', 'testvendor', 'Password to use with the Sagepay Form service. Normally your encyption password', '6', '2', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Mode', 'MODULE_PAYMENT_SAGEPAY_FORM_TEST_STATUS', 'simulator', 'Use Simulator, Test or Live Mode?', '6', '3', 'zen_cfg_select_option(array(\'simulator\', \'test\', \'live\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Type', 'MODULE_PAYMENT_SAGEPAY_FORM_TXTYPE', 'Payment', 'Use Pre-Authorisation for all transactions?', '6', '4', 'zen_cfg_select_option(array(\'Payment\', \'Deferred\', \'Authenticate\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Currency', 'MODULE_PAYMENT_SAGEPAY_FORM_CURRENCY', 'Default Currency', 'The currency to use for credit card transactions', '6', '5', 'zen_cfg_select_option(array(\'Default Currency\', \'GBP\', \'EUR\', \'USD\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_SAGEPAY_FORM_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '6', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_SAGEPAY_FORM_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '7', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_SAGEPAY_FORM_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '8', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
	  $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Shopping cart', 'MODULE_PAYMENT_SAGEPAY_FORM_SHOPCART', 'true', 'Send shopping cart details to Sagepay?', '6', '9', 'zen_cfg_select_option(array(\'true\', \'false\'), ', now())");
	  $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Send Email', 'MODULE_PAYMENT_SAGEPAY_FORM_SENDEMAIL', 'both', 'Should Sagepay send order emails to the vendor only, both the vendor and the customer (default) or no email sent to either?', '6', '12', 'zen_cfg_select_option(array(\'none\', \'both\', \'vendor\'), ', now())");
	}

    function remove() {
      global $db;
      $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array(
			'MODULE_PAYMENT_SAGEPAY_FORM_STATUS', 
			'MODULE_PAYMENT_SAGEPAY_FORM_VENDOR_NAME', 
			'MODULE_PAYMENT_SAGEPAY_FORM_PASSWORD', 
			'MODULE_PAYMENT_SAGEPAY_FORM_TEST_STATUS', 
			'MODULE_PAYMENT_SAGEPAY_FORM_TXTYPE', 
			'MODULE_PAYMENT_SAGEPAY_FORM_CURRENCY', 
			'MODULE_PAYMENT_SAGEPAY_FORM_SORT_ORDER', 
			'MODULE_PAYMENT_SAGEPAY_FORM_ZONE', 
			'MODULE_PAYMENT_SAGEPAY_FORM_ORDER_STATUS_ID', 
			'MODULE_PAYMENT_SAGEPAY_FORM_SHOPCART', 
			'MODULE_PAYMENT_SAGEPAY_FORM_SENDEMAIL' 
			);
    }
  }
?>